<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of install-class
 *
 * @author Stephen
 */

 class localmoney {

	 public function __construct() {

		/*
		 * Make it international
		 */ 

		load_plugin_textdomain('localmoney', false, basename( dirname( __FILE__ ) ) . '/languages' );

		/*
		 * Enqueue the javascript into the footer of the page.
		 */

		function enqueue_scripts() {
			wp_enqueue_script('lm_client_side', 
							  plugins_url( 'javascript.js', dirname(__FILE__) ),
							  array('jquery'), 
							  '0.2', 
							  true);
		}

		add_action('wp_enqueue_scripts', 'enqueue_scripts');
		
		/*
		 * When serving a post or listing excerpts trigger the marking of prices in the
		 * page.
		 */

		function localmoney($content) {

			/*
			 * Get the options for the plugin
			 */

			$options = get_option('localmoney_options');
			$base = explode(':',$options['base_currency']);
			$base_currency = $base[0];
			$old_pattern = $base[1];
			$old_regex = '/[^a-zA-Z]'.str_replace(array('*','$'),array('[0-9]*\.?[0-9]*','\$'),$old_pattern).'/';
						
			/*
			 * Load the rates data into an array
			 */

			$json = file_get_contents(dirname(__DIR__).'/cache.txt');
			$json_object = json_decode($json,true);
			$rates_base = $json_object['base'];
			$rates = $json_object['rates'];
						
			if ($base_currency != $rates_base || true) {
				
				$rate = 1/$rates[$base_currency];
				
				$callback = function($match) use ($rate) {
					return convert($match,$rate);
				};
												
				$content = preg_replace_callback($old_regex, $callback, $content);
				
			} else {

				$content = preg_replace('/([^a-zA-Z])(\$[0-9]*\.?[0-9]*)/','$1<span class="currency">$2</span>',$content);
			
			}

			// Done
			return $content;
		}
		
		function convert($match,$rate) {
			$match = $match[0];
			$chars = preg_split('//u',$match);
			$match = '';
			foreach ($chars as $c) {
				if ($c != '' && strpos('0123456789.',$c) !== false) $match .= $c;
			}
			$cents = strpos($match,'.') !== false ? 2 : 0;
			$match = preg_replace('/^[^0-9]*([0-9.]*).*$/','$1',$match);
			$number = number_format($match*$rate+0.5,$cents,'.','');
			return $chars[1].'<span class="currency">$'.$number.'</span>';
		}

		add_filter('the_content', 'localmoney');
		add_filter('the_excerpt', 'localmoney');
		//add_filter('the_excerpt_rss', 'localmoney');

	}
 }



?>
